From 840615ed276c7b94db70e817a4dde729278684e4 Mon Sep 17 00:00:00 2001
From: Nathaniel Manista <nathaniel@google.com>
Date: Thu, 22 Jan 2015 20:31:47 +0000
Subject: [PATCH] Add Python to run-tests.

---
 .gitignore                      |  3 +++
 INSTALL                         |  2 +-
 tools/run_tests/build_python.sh | 10 ++++++++++
 tools/run_tests/run_python.sh   | 10 ++++++++++
 tools/run_tests/run_tests.py    | 18 +++++++++++++++++-
 5 files changed, 41 insertions(+), 2 deletions(-)
 create mode 100755 tools/run_tests/build_python.sh
 create mode 100755 tools/run_tests/run_python.sh

diff --git a/.gitignore b/.gitignore
index 63332d1b16..002e3e661c 100644
--- a/.gitignore
+++ b/.gitignore
@@ -4,6 +4,9 @@ gens
 libs
 objs
 
+# Python virtual environment (pre-3.4 only)
+python2.7_virtual_environment
+
 # gcov coverage data
 coverage
 *.gcno
diff --git a/INSTALL b/INSTALL
index 98c20f5898..48511aff7d 100644
--- a/INSTALL
+++ b/INSTALL
@@ -17,7 +17,7 @@ A typical unix installation won't require any more steps than running:
 You don't need anything else than GNU Make and gcc. Under a Debian or
 Ubuntu system, this should boil down to the following package:
 
-  # apt-get install build-essential
+  # apt-get install build-essential python-all-dev python-virtualenv
 
 
 *******************************
diff --git a/tools/run_tests/build_python.sh b/tools/run_tests/build_python.sh
new file mode 100755
index 0000000000..6899ac7fe3
--- /dev/null
+++ b/tools/run_tests/build_python.sh
@@ -0,0 +1,10 @@
+#!/bin/bash
+
+set -ex
+
+# change to grpc repo root
+cd $(dirname $0)/../..
+
+root=`pwd`
+virtualenv python2.7_virtual_environment
+python2.7_virtual_environment/bin/pip install enum34==1.0.4 futures==2.2.0
diff --git a/tools/run_tests/run_python.sh b/tools/run_tests/run_python.sh
new file mode 100755
index 0000000000..0d5ed0238d
--- /dev/null
+++ b/tools/run_tests/run_python.sh
@@ -0,0 +1,10 @@
+#!/bin/bash
+
+set -ex
+
+# change to grpc repo root
+cd $(dirname $0)/../..
+
+root=`pwd`
+python2.7_virtual_environment/bin/python2.7 -B -m unittest discover -s src/python -p '*.py'
+python3.4 -B -m unittest discover -s src/python -p '*.py'
diff --git a/tools/run_tests/run_tests.py b/tools/run_tests/run_tests.py
index 15c523731b..da849f04cb 100755
--- a/tools/run_tests/run_tests.py
+++ b/tools/run_tests/run_tests.py
@@ -75,6 +75,21 @@ class PhpLanguage(object):
     return [['tools/run_tests/build_php.sh']]
 
 
+class PythonLanguage(object):
+
+  def __init__(self):
+    self.allow_hashing = False
+
+  def test_binaries(self, config):
+    return ['tools/run_tests/run_python.sh']
+
+  def make_targets(self):
+    return[]
+
+  def build_steps(self):
+    return [['tools/run_tests/build_python.sh']]
+
+
 # different configurations we can run under
 _CONFIGS = {
     'dbg': SimpleConfig('dbg'),
@@ -92,7 +107,8 @@ _DEFAULT = ['dbg', 'opt']
 _LANGUAGES = {
     'c++': CLanguage('cxx', 'c++'),
     'c': CLanguage('c', 'c'),
-    'php': PhpLanguage()
+    'php': PhpLanguage(),
+    'python': PythonLanguage(),
 }
 
 # parse command line
-- 
GitLab